#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <float.h>

#include "include.h"
#include "device.h"
#include "cloud.h"
#include "edge.h"
#include "task.h"

enum best_method{	EFT, ACT, LST};

int bf(enum best_method method)
{
	finish_size = 0.0;
	int index_task, index_edge, index_srv, index_core, index_cloud, index_vm;
	struct task *pos_task = NULL;
	struct dev *pos_dev = NULL;
	struct edge *pos_edge = NULL;
	struct server *pos_srv = NULL;
	struct core *pos_core = NULL;
	struct cloud *pos_cloud = NULL;
	struct vm *pos_vm = NULL;
	struct core *best_core = NULL;
	struct cloud *best_cloud = NULL;
	struct vm *best_vm = NULL;
	int finish_task = 0;
	double ft = 0.0, ft_input = 0.0, act = 0.0, st = 0.0;
	double best_ft, best_ft_input, best_act, best_st;
	int flag = 0; //1 for device, 2 for edge, 3 for cloud
	int update, update_new;
	for(index_task=0; index_task<num_task; index_task++)
	{
		best_core = NULL;
		best_cloud = NULL;
		best_vm = NULL;
		best_ft = DBL_MAX;
		best_ft_input = DBL_MAX;
		best_act = DBL_MAX;
		best_st = DBL_MAX;
		flag = 0;
		pos_task = tasks + index_task;
		//device
		pos_dev = pos_task->dev;
		for(index_core=0; index_core < pos_dev->num_core; index_core++)
		{
			update = 0;
			pos_core = pos_dev->cores + index_core;
			ft = pos_task->size / pos_dev->ghz + pos_core->time_c;
			act = pos_task->size / pos_dev->ghz;
			st = pos_task->deadline - ft;
			if(ft <= pos_task->deadline)
			{
				switch(method)
				{
					case EFT:
						if(best_ft > ft)
						{
							best_ft = ft;
							update = 1;
						}
						break;
					case ACT:
						if(best_act > act)
						{
							best_act = act;
							update = 1;
						}
						break;
					case LST:
						if(best_st > st)
						{
							best_st = st;
							update = 1;
						}
						break;
					default:
						printf("to be implemented\n");
						exit(11);
				}
				if(update)
				{
					best_core = pos_core;
					best_ft = ft;
					flag = 1;
				}
			}
		}
		//edge
		for(index_edge=0; index_edge<num_edge; index_edge++)
		{
			if(pos_dev->edge != index_edge)
				continue;//skip edges not coverring the device
			pos_edge = edges + index_edge;
			for(index_srv=0; index_srv < pos_edge->num_srv; index_srv++)
			{
				pos_srv = pos_edge->srv + index_srv;
				for(index_core=0; index_core < pos_srv->num_core; index_core++)
				{
					update = 0;
					pos_core = pos_srv->cores + index_core;
					ft_input = pos_task->input / pos_edge->bw_down * 8  + pos_core->time_in;
					if(ft_input < pos_core->time_c)
						ft = pos_task->size / pos_srv->ghz + pos_core->time_c;
					else
						ft = pos_task->size / pos_srv->ghz + ft_input;
					act = pos_task->size / pos_srv->ghz + pos_task->input / pos_edge->bw_down * 8;
					st = pos_task->deadline - ft;
					if(ft <= pos_task->deadline)
					{
						switch(method)
						{
							case EFT:
								if(best_ft > ft)
								{
									best_ft = ft;
									update = 1;
								}
								break;
							case ACT:
								if(best_act > act)
								{
									best_act = act;
									update = 1;
								}
								break;
							case LST:
								if(best_st > st)
								{
									best_st = st;
									update = 1;
								}
								break;
							default:
								printf("to be implemented\n");
								exit(11);
						}
						if(update)
						{
							best_core = pos_core;
							best_ft = ft;
							best_ft_input = ft_input;
							flag = 2;
						}
					}
				}
			}
		}
		//cloud
		for(index_cloud=0; index_cloud < num_cloud; index_cloud++)
		{
			pos_cloud = clouds + index_cloud;
			for(index_vm=0; index_vm<pos_cloud->num_vm; index_vm++)
			{
				update = 0;
				pos_vm = pos_cloud->vms[index_vm];
				ft_input = pos_task->input / pos_cloud->bw_down * 8  + pos_vm->time_in;
				if(ft_input < pos_vm->time_c)
					ft = pos_task->size / pos_cloud->ghz + pos_vm->time_c;
				else
					ft = pos_task->size / pos_cloud->ghz + ft_input;
				act = pos_task->size / pos_cloud->ghz + pos_task->input / pos_cloud->bw_down * 8;
				st = pos_task->deadline - ft;
				if(ft <= pos_task->deadline)
				{
					switch(method)
					{
						case EFT:
							if(best_ft > ft)
							{
								best_ft = ft;
								update = 1;
							}
							break;
						case ACT:
							if(best_act > act)
							{
								best_act = act;
								update = 1;
							}
							break;
						case LST:
							if(best_st > st)
							{
								best_st = st;
								update = 1;
							}
							break;
						default:
							printf("to be implemented\n");
							exit(11);
					}
					if(update)
					{
						best_cloud = pos_cloud;
						best_vm = pos_vm;
						best_ft = ft;
						best_ft_input = ft_input;
						flag = 3;
					}
				}
			}
		}
		if(0 == flag)
		{
			update_new = 0;
			//need rent a new vm from a cloud
			for(index_cloud=0; index_cloud < num_cloud; index_cloud++)
			{
				update = 0;
				pos_cloud = clouds + index_cloud;
				if(pos_cloud->num_vm == MAX_VM)
				{
					printf("VM number is belong to %d\n", MAX_VM);
					exit(0);
				}
				ft_input = pos_task->input / pos_cloud->bw_down * 8;
				ft = pos_task->size / pos_cloud->ghz + ft_input;
				act = pos_task->size / pos_cloud->ghz + pos_task->input / pos_cloud->bw_down * 8;
				st = pos_task->deadline - ft;
				if(ft <= pos_task->deadline)
				{
					switch(method)
					{
						case EFT:
							if(best_ft > ft)
							{
								best_ft = ft;
								update = 1;
							}
							break;
						case ACT:
							if(best_act > act)
							{
								best_act = act;
								update = 1;
							}
							break;
						case LST:
							if(best_st > st)
							{
								best_st = st;
								update = 1;
							}
							break;
						default:
							printf("to be implemented\n");
							exit(11);
					}
					if(update)
					{
						best_cloud = pos_cloud;
						update_new = 1;
					}
				}
			}
			if(update_new)
			{
				pos_vm = (struct vm *)malloc(sizeof(struct vm));
				memset(pos_vm, 0, sizeof(struct vm));
				best_cloud->vms[index_vm] = pos_vm;
				best_cloud->num_vm++;
				best_vm = pos_vm;
				best_ft_input = ft_input;
				best_ft = ft;
				flag = 3;
			}
		}
		if(flag)
		{
			finish_task++;
			finish_size += pos_task->size;
		}
		//device
		if(1 == flag)
		{
			best_core->time_c = best_ft;
			insert_tail(&best_core->tasks, pos_task, &best_core->tail);
			best_core->num_task++;
		}
		else if(2 == flag)
		//edge
		{
			best_core->time_c = best_ft;
			best_core->time_in = best_ft_input;
			insert_tail(&best_core->tasks, pos_task, &best_core->tail);
			best_core->num_task++;
		}
		//cloud
		else if(3 == flag)
		{
			best_vm->time_c = best_ft;
			best_vm->time_in = best_ft_input;
			insert_tail(&best_vm->tasks, pos_task, &best_vm->tail);
			best_vm->num_task++;
		}
	}
	return finish_task;
}

int eftf()
{
	return bf(EFT);
}

int lact()
{
	return bf(ACT);
}

int lstf()
{
	return bf(LST);
}

