#ifndef _CLOUD_H_
#define _CLOUD_H_
#include "include.h"
#include "task.h"


#define MAX_CLOUD 1
#define MAX_VM 5000


struct vm{
	int id;
	double time_c;//computing time
    double time_in;//input data time
	int num_task; //the number of tasks assigned to the core
    struct task *tasks;//task list assigned to the core
    struct task *tail; //the last task, used for insert a task into the tail of tasks;
};

struct cloud{//vm types, assuming each cloud provides one vm type
	int id;
	float ghz; //computing capacity of a core, Hz
	float gflops; //computing capacity of a core, Hz
	float price; //price of a core in each hour
	float bw_up; //bandwidth
	float bw_down; //bandwidth
	struct vm *vms[MAX_VM];//assuming each vm has one core, as the price per core is constant for each type
	int num_vm;
};

extern struct cloud clouds[MAX_CLOUD];
extern int num_cloud;



void init_cloud();
#endif
