#include <string.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include "device.h"


struct dev devs[MAX_DEV];
int num_dev = 20;
int dev_energy_budget = 5000; //W

void init_dev()
{
	memset(devs, 0, MAX_DEV * sizeof(struct dev));
	int i;
	for(i=0; i<num_dev; i++)
	{
		devs[i].id = i;
		devs[i].ghz = 1.0 * rand() / RAND_MAX + 1; // [1, 2] GHz
		devs[i].num_core = rand() % 4 + 1; //1, 2, 3, 4
		devs[i].edge = rand() % num_edge;
		devs[i].lat = rand() % radius + 1;
		devs[i].lon = rand() % radius + 1;
		devs[i].mem = 1536.0 * rand() / RAND_MAX + 512; // [0.5, 2] GB
		//CJ-CN2020-12-Near-optimal and learning-driven task offloading in a 5G multi-cell mobile edge cloud
		devs[i].pow_busy = 0.5;
		devs[i].pow_idle = 0.05;
		devs[i].pow_trans = 0.2;
		//An Effective Offloading Trade-Off to Economize Energy and Performance in Edge Computing
		devs[i].pow_budget = 5000000; //J, 50\% full charge
	}
}

