#ifndef _DEVICE_H_
#define _DEVICE_H_
#include "include.h"
#include "task.h"
#include "edge.h"
#include "cloud.h"

#define MAX_TASK_DEV 100
// user devices
struct dev{
	int id;
	float ghz; //computing capacity of each core, Hz
    double gflops; //for each core
	int num_core; //core number
	float mem; //MB
	float lon;//Longitude
	float lat;//latitude
	int edge; //which edge covering the device, which can be deduced by lon and lat
	float pow_idle; //W
	float pow_busy; //W
	float pow_trans; //W
	float pow_budget; // J = W * s
	struct core cores[MAX_CORE];
	struct task tasks[MAX_TASK_DEV];
	int num_task;
	//for data transfer energy calculation
	float updata;
	float updata_edge[MAX_EDGE];
	float updata_cloud[MAX_CLOUD];
	float downdata;
	//
	float energy;
};

#define MAX_DEV 100
extern struct dev devs[MAX_DEV];
extern int num_dev;
extern int dev_energy_budget; //W


void init_dev();
#endif
