#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "edge.h"

int radius = 500; // the cover circle area of an edge in meter

struct edge edges[MAX_EDGE];
int num_edge = 2;


void init_edge()
{
	memset(edges, 0, MAX_EDGE * sizeof(struct edge));
	int i, j;
	for(i=0; i<num_edge; i++)
	{
		edges[i].num_srv = rand() % 4 + 1; //1, 2, 3, 4
		edges[i].id = i;
		for(j=0; j<edges[i].num_srv; j++)
		{
			edges[i].srv[j].id = j;
			edges[i].srv[j].ghz = 1.0 * rand() / RAND_MAX + 2; // [2, 3] GHz;
			edges[i].srv[j].num_core = rand() % 5 + 4; //4, 5, 6, 7, 8
			edges[i].srv[j].mem = (12.0 * rand() / RAND_MAX + 4) * 1024; // [4, 16] GB
			if(edges[i].srv[j].num_core <= 6)
			{
				edges[i].srv[j].power_idle = 110;
				edges[i].srv[j].power_full = 175;
			}
			else if(edges[i].srv[j].num_core <= 12)
			{
				edges[i].srv[j].power_idle = 125;
				edges[i].srv[j].power_full = 210;
			}
			else
			{
				edges[i].srv[j].power_idle = 210;
				edges[i].srv[j].power_full = 300;
			}
		}
		edges[i].bw_up = 90.0 * rand() / RAND_MAX + 10; //10~100 Mbps
		edges[i].bw_down = 90.0 * rand() / RAND_MAX + 10; //10~100 Mbps
		edges[i].lat = rand() % radius + 1;
		edges[i].lon = rand() % radius + 1;
	}
}

