#ifndef _EDGE_H_
#define _EDGE_H_
#include "include.h"
#include "task.h"

struct server{
	int id;
    int num_core;
    double ghz; //for each core
    double gflops; //for each core
    int mem; //GB
    struct core cores[MAX_CORE];
    double power_idle;
    double power_full;
    double power_sleep;
};

#define MAX_SRV 4
struct edge{
	int id;
	struct server srv[MAX_SRV];
	int num_srv; //the number of servers in the edge
	float bw_up; //bandwidth
	float bw_down; //bandwidth
	double lat; //latitude
	double lon;   //longitude 
};


//H: 500m; L: 30m radius
//in 2017-11-A strategy for joint service offloading and scheduling in heterogeneous cloud radio access networks
//(EURASIP Journal on Wireless Communications and Networking)
extern int radius; // the cover circle area of an edge in meter

#define MAX_EDGE 5

extern struct edge edges[MAX_EDGE];
extern int num_edge;


void init_edge();

#endif
