#ifndef _QPSO_H_
#define _QPSO_H_

enum update_alpha{LINEAR, QUADRATIC, QUAD_DEC, ADAPTIVE};


int qpso_core(double (*update_pos)(double code_max[MAX_TASKS], double code_min[MAX_TASKS]),
		enum update_alpha update_a, double alpha_min, double alpha_max);

double qpos_update(double code_max[MAX_TASKS], double code_min[MAX_TASKS]);
double gqpos_update(double code_max[MAX_TASKS], double code_min[MAX_TASKS]);
double lqpos_update(double code_max[MAX_TASKS], double code_min[MAX_TASKS]);
double hwqpos_update(double code_max[MAX_TASKS], double code_min[MAX_TASKS]);
double qpos_cd_update(double code_max[MAX_TASKS], double code_min[MAX_TASKS]);
double qpos_cauchy_update(double code_max[MAX_TASKS], double code_min[MAX_TASKS]);


int tour_qpso_core(		double (*update_pos)(struct particle *pcls, int num_pcls, 
												double code_max[MAX_TASKS], double code_min[MAX_TASKS]),
							struct particle* (*tournament)(struct particle *swarm1, struct particle *swarm2, int num_pcls),
							double alpha_min, double alpha_max);
double tour_gpso_update(struct particle *pcls, int num_pcls, double code_max[MAX_TASKS], double code_min[MAX_TASKS]);
struct particle *tournament(struct particle *swarm1, struct particle *swarm2, int num_pcls);





#endif
