#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "task.h"
#include "device.h"


struct task tasks[MAX_TASKS];

double taskSize = 0.0; //total task size
double total_input = 0.0;//total input data size
int num_task = 0; //fixed total number of sizes

int init_tsks()
{
	srand((unsigned)time(NULL));
	int i, j, k = 0;
	struct dev *cur_dev;
	num_task = 0;
	taskSize = 0;
	for(i=0; i<num_dev; i++)
	{
		cur_dev = devs + i;
		cur_dev->num_task = rand() % MAX_TASK_DEV + 1;
		num_task += cur_dev->num_task;
		for(j=0; j<cur_dev->num_task; j++)
		{
			cur_dev->tasks[j].size = 1900.0 * rand() / RAND_MAX + 100; //任务计算量在[100, 2000]GHz之间随机生成
			taskSize += cur_dev->tasks[j].size;
			//CJ-JNCA2020-12-Data-intensive application scheduling on Mobile Edge Cloud Computing
			cur_dev->tasks[j].input = rand() % 481 + 20;//任务的输入数据量在[20, 500]MB之间随机生成
			total_input += cur_dev->tasks[j].input;
			tasks[i].output = tasks[i].input * 0.1;
			cur_dev->tasks[j].deadline = rand() % 901 + 100; //任务截止时间在[100, 1000]s之间随机生成 
			tasks[i].para = rand() % 32 + 1; //1 ~ 32
			
			cur_dev->tasks[j].id = k;
			cur_dev->tasks[j].dev = cur_dev;
			
			memcpy(tasks+k, cur_dev->tasks +j, sizeof(struct task));
			k++;
		}
	}
	return num_task;
}



//return the head of task list
struct task *insert_dl_inc(struct task **head, struct task *tsk, struct task **tail)
{
	struct task *pos, *pre;
	if(NULL == *head)
	{
		*head = tsk;
		*tail = tsk;
		tsk->next = NULL;
		return *head;
	}
	if((*head)->deadline > tsk->deadline)
	{
		tsk->next = *head;
		*head = tsk;
		return *head;
	}
	pre = *head;
	pos = pre->next;
	while(pos && (pos->deadline < tsk->deadline))
	{
		pre = pos;
		pos = pos->next;
	}
	pre->next = tsk;
	tsk->next = pos;
	if(NULL == pos)
		*tail = tsk;
	return *head;
}

//return the head of task list
struct task *insert_tail(struct task **head, struct task *tsk, struct task **tail)
{
	if(NULL == *head)
	{
		*head = tsk;
		*tail = tsk;
		tsk->next = NULL;
		return *head;
	}
	else
	{
		(*tail)->next = tsk;
		tsk->next = NULL;
		*tail = tsk;
	}
	return *head;
}

//return the task deleted
struct task *del_task_list(struct task **head, struct task *tsk, struct task **tail)
{
	struct task *pos = *head;
	struct task *pre = NULL;
	while(pos && pos != tsk)
	{
		pre = pos;
		pos = pos->next;
	}
	if(pos)
	{
		if(pos == *head)//deleting the head
		{
			*head = pos->next;
			if(*tail == tsk)//only one task in the list, and it is to be deleted
			{
				*tail = NULL;
			}
		}
		else
		{
			pre->next = pos->next;
			if(*tail == tsk)
			{
				*tail = pre;
			}
		}
	}
	tsk->next = NULL;
	return tsk;
}


//return the number of tasks
int del_task_array(struct task tsks[], int *num, int index)
{
	int i;
	for(i=index; i<*num - 1; i++)
	{
		tsks[i] = tsks[i+1];
	}
	(*num)--;
	return *num;
}

void print_tasklist(struct task *list)
{
	struct task *pos = list;
	for(pos=list; pos; pos=pos->next)
	{
		printf("%d, ", pos->id);
	}
	printf("\n");
}
void print_tasks(struct task *tsks, int num)
{
	int i;
	for(i=0; i<num; i++)
	{
		printf("%d, ", tsks[i].id);
	}
	printf("\n");
}



int compare_dl_inc(const void *p1, const void *p2)
{
	struct task *tsk1, *tsk2;
	tsk1 = (struct task *)p1;
	tsk2 = (struct task *)p2;
	return (int)(tsk1->deadline - tsk2->deadline);
}
void sort_task_deadline_inc()
{
	qsort(tasks, num_task, sizeof(struct task), compare_dl_inc);
}

int compare_length_dec(const void *p1, const void *p2)
{
	struct task *tsk1, *tsk2;
	tsk1 = (struct task *)p1;
	tsk2 = (struct task *)p2;
	return (int)(tsk2->size - tsk1->size);
}
void sort_task_length_dec()
{
	qsort(tasks, num_task, sizeof(struct task), compare_length_dec);
}

void sort_task_length_dec_part(struct task tasks[], int num_task)
{
	qsort(tasks, num_task, sizeof(struct task), compare_length_dec);
}


int compare_input_dec(const void *p1, const void *p2)
{
	struct task *tsk1, *tsk2;
	tsk1 = (struct task *)p1;
	tsk2 = (struct task *)p2;
	return (int)(tsk2->input - tsk1->input);
}
void sort_task_input_dec()
{
	qsort(tasks, num_task, sizeof(struct task), compare_input_dec);
}


