#ifndef _TASKS_H_
#define _TASKS_H_


struct task{
	int id;
	double size; //runtime * para * hz
	long submit;
	long runtime;
	long wait;
	int para;
	double deadline;
	double input;
	double output;
	struct dev *dev;
	struct task *next;
};

#define MAX_TASKS 2000
extern struct task tasks[MAX_TASKS];

extern double taskSize; //total task size
extern double total_input; //total tasks' input data size
extern int num_task; //fixed total number of sizes
extern double total_input;


int init_tsks();

//return the head of task list
struct task *insert_dl_inc(struct task **head, struct task *tsk, struct task **tail);
//return the head of task list
struct task *insert_tail(struct task **head, struct task *tsk, struct task **tail);
//return the task deleted
struct task *del_task_list(struct task **head, struct task *tsk, struct task **tail);
//return the number of tasks
int del_task_array(struct task tsks[], int *num, int index);

void print_tasklist(struct task *list);
void print_tasks(struct task *tsks, int num);

void sort_task_deadline_inc();
void sort_task_length_dec();
void sort_task_input_dec();
void sort_task_length_dec_part(struct task tasks[], int num_task);


#endif
